using System;
using System.Collections;

namespace com.macromedia.mesh.log
{
	public class LoggerArrayList : CollectionBase
	{
		protected Type classType;
		protected const string className = "com.macromedia.mesh.log.Logger";

		public LoggerArrayList()
		{
			classType = Type.GetType(className);
		}

		public Logger this[ int index ]  
		{
			get  
			{
				return( (Logger) List[index] );
			}
			set  
			{
				List[index] = value;
			}
		}

		public int Add( Logger value )  
		{
			return( List.Add( value ) );
		}

		public int IndexOf( Logger value )  
		{
			return( List.IndexOf( value ) );
		}

		public void Insert( int index, Logger value )  
		{
			List.Insert( index, value );
		}

		public void Remove( Logger value )  
		{
			List.Remove( value );
		}

		public bool Contains( Logger value )  
		{
			// If value is not of type Logger, this will return false.
			return( List.Contains( value ) );
		}

		protected void OnInsert( int index, Logger value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "value" );
		}

		protected void OnRemove( int index, Logger value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "value" );
		}

		protected void OnSet( int index, Logger oldValue, Logger newValue )  
		{
			if ( !(oldValue.GetType().IsSubclassOf(classType)) || !(newValue.GetType().IsSubclassOf(classType)))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "newValue" );
		}

		protected void OnValidate( Logger value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString() );
		}
	}
}
