using System;
using System.IO;
using com.macromedia.mesh.log;

namespace com.macromedia.mesh.log.unittest
{
	/// <summary>
	/// Summary description for UnitTestLogger.
	/// </summary>
	public class LoggerUnitTest
	{
		public static void Main(string[] args)
		{

			Console.WriteLine("---------Testing LoggerManager--------");
			LoggerManager lm = new LoggerManager();

			Console.Out.WriteLine();
			Console.WriteLine("Adding ConsoleLogger");
			lm.Add(new ConsoleLogger());

			Console.Out.WriteLine();
			Console.WriteLine("Adding FileLogger");

			FileLogger fl = new FileLogger("c:\\temp\\dir\\test.log", true);
			fl.TimeStampFormat = "F";

			lm.Add(fl);

			Console.Out.WriteLine("WriteLine(\"test\") : ");
			lm.WriteLine("test");
			Console.Out.WriteLine("<--");

			Console.Out.WriteLine();

			Console.Out.WriteLine("Flush() : ");
			lm.Flush();
			Console.Out.WriteLine("<--");

			Console.Out.WriteLine();

			Console.Out.WriteLine("Close() : ");
			lm.Close();
			Console.Out.WriteLine("<--");

			Console.Out.WriteLine();

			Console.Out.WriteLine("---------Testing Complete-----------");

			Console.Out.WriteLine();

		}
	}
}
